/* bxbasm : AsmVars.c : alpha version */
/* ----- includes ----- */
#include "prototyp.h"




void Do_dim()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, type, dim, value;

    dim = (int) get_avalue();			/* get number of dimensions */
		/**/					/* enter: 2,a$(a,b) */
    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;  
    strcpy(varname, get_varname());		/* get this array name */

  /* printf("pi=%d len=%d varname=%s\n", pi, len, varname); */
		/**/
    type = get_vtype(pi);
    if(type == 6)
    {   strcat(varname, "$");
    }
		/**/
    writeln("; --------------------------------------------------");
    write_str("  mov  esi, offset ");	/* string array pointer */
    writeln(varname);
    writeln("  mov  edi, esi");
    writeln("  add  edi, 4");
		/**/
    pi = e_pos;
    pi = get_paren(pi, len);			/* DIM array$(3,10) */
    s_pos = pi;					/* ----------^      */
    ch = p_string[pi];
    while((ch != ')') && (ch != '\n'))
    {   pi = get_alnum(pi, len);
        e_pos = pi;
        ch = p_string[pi];
        if(isdigit(ch))
        {   value = (int) get_avalue();
            sprintf(temp, "%d", value);
            writeln("  add  edi, 2");
            write_str("  mov word ptr [edi], ");
            writeln(temp);
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());
            write_str("  mov  eax, ");
            writeln(varname);
            writeln("  add  edi, 2");
            writeln("  mov word ptr [edi], ax");
        }
        pi = e_pos;
        ch = p_string[pi];
    }
    if(type == 6) 					/* string$ array */
    {   writeln("  call dimstrarray");
        dimstrarray = 1;
    }
  /* ... */

}
/*---------- end Do_dim ----------*/


void Do_color()
{   char ch, varname[VAR_NAME];
    int pi, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhiter(pi);
    e_pos = pi;
    strcpy(varname, get_varname());
    write_str("  mov  eax, ");
    writeln(varname);
		/**/
    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;
    strcpy(varname, get_varname());
    write_str("  mov  ebx, ");
    writeln(varname);
    writeln("  call setcolortext");
    setcolortext = 1;
}
/*---------- end Do_color ----------*/


void clr_vars()
{   char ch, varname[VAR_NAME];
    int pi, len, type;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    writeln("; --------------------------------------------------");
		/**/
    if(pi == len)
    {   writeln("  call clear_allvars");
        clearallvars = 1;
    }
    else
    {   while(pi < len)
        {   e_pos = pi;
            strcpy(varname, get_varname());
            pi = e_pos;
            type = get_vtype(pi);
            if(type == 3)      		/* string variable */
            {   strcat(varname, "$");
                write_str("  mov  esi, offset ");
                writeln(varname);
                writeln("  call clearstrvar");
				/**/
                clearstrvar = 1;
            }
            else
            {   type = get_Nvtype(pi);
                if(type < 3)					/* clear integers */
                {   write_str("  mov  esi, offset ");
                    writeln(varname);
                    writeln("  call clearintvar");
				/**/
                    clearintvar = 1;
                }
                else						/* clear floats */
                {   write_str("  mov  esi, offset ");
                    writeln(varname);
                    writeln("  call clearfltvar");
				/**/
                    clearfltvar = 1;
                }
            }
            pi = e_pos;
            pi = get_alpha(pi, len);
        }
    }
}
/*---------- end clr_vars ----------*/


void Do_let()
{   char ch, varname[VAR_NAME];
    int pi, len, ndx=0, type;
    int ab_code=6, x=line_ndx;

    len = strlen(p_string);
    pi = e_pos;
		/**/
    pi = get_alpha(pi, len);  		/* retrieve variable name */
    if(pi == len)					/* error: didn't find it */
    {   a_bort(ab_code, x);
    }
    e_pos = pi;
    strcpy(varname, get_varname());
    type = get_vtype(pi);			/* get variable type */
		/**/
    if(type == 3)  				/* now have varname and type */
    {   parse_str(varname);	    		/* string variable assignment */
    }
    else if(type == 6)
    {   parse_strArry(varname);	    	/* string array assignment */
    }
    else
    {   type = get_Nvtype(pi);		/* get var-type length */
        var_type = type;			/* set global variable */
        if((type == 3) || (type == 4))	/* --- floating point --- */
        {   asn_float(type,varname);
        }
        else if(type != 0)      		/* --- integers --- */
        {   asn_integer(type,varname);
        }
        else
        {   a_bort(ab_code, x);
        }
    }
}
/*---------- end Do_let ----------*/


void asn_integer(int type, char *name)
{   char ch, varname[VAR_NAME];
    int pi;

    pi = e_pos;
    pi = iswhite(pi);
    e_pos = pi;
    strcpy(varname, name);
    if((type == 2) || (type == 5))		/* 32/64-Bit Long Integer */
    {   pi++;					/* skip over 'type' symbol */
        pi = iswhite(pi);
        e_pos = pi;
    }
    writeln("; --------------------------------------------------");
	/**/
    Assignment();				/* call: recursive descent parser */
  /* --- store data --- */
    write_str("  FISTP ");
    write_str(varname);
    writeln("\t\t; store integer, pop stack");
}
/*---------- end asn_integer ----------*/


void asn_float(int type, char *name)
{   char ch, varname[VAR_NAME];
    int pi;

    pi = e_pos;
    pi = iswhite(pi);
    e_pos = pi;
    strcpy(varname, name);
    pi++;						/* skip over 'type' symbol */
    pi = iswhite(pi);
    e_pos = pi;
    writeln("; --------------------------------------------------");
		/**/
    Assignment();				/* call: recursive descent parser */
  /* --- store data --- */
    write_str("  FSTP  ");
    write_str(varname);
    writeln("\t\t; store float, pop stack");
}
/*---------- end asn_float ----------*/


void get_input()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, type, mark, loc=0, ab_code=5, x=line_ndx;

    pi = e_pos;					/* INPUT;"text", var,[var,] */
    ch = p_string[pi];
    if(ch == '#')  			/* this is a file: [INPUT#1, var:] */
    {   input_io();
        return;
    }
    else if(ch == ';')				/* do not echo newline */
    {   loc = 1;					/* Location Of Cursor */
        resetcursor = 1;
        pi = get_rightExp(pi);	/* get to next alpha or string */
        ch = p_string[pi];
        e_pos = pi;
    }
    len = strlen(p_string);
    while((pi < len) && (ch != '\n'))        /* process to end of line */
    {   strcpy(temp, "VARX");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;
        if((mark >= 0) && (mark == pi))
        {   mark = 1;
        }
        else 
        {   mark = 0;
        }
		/**/
        if(mark == 1)				/* OUPUT a quoted string */
        {   strcpy(varname, get_varname());
            strcat(varname, "$");
            write_str("  printstr ");
            writeln(varname);
        }
        else if(isalpha(ch))	    /* INPUT a string$ or numeric variable */
        {   type = get_vtype(pi);
            strcpy(varname, get_varname());
            pi = e_pos;
            if(loc == 1)
            {   writeln("  call wherexy");
            }
			/**/
            if(type == 3)				/* a string$ assignment */
            {   strcat(varname, "$");
                pi++;
                e_pos = pi;
                writeln("  lea  eax, StringBffr");
                writeln("  mov  [eax], byte ptr 0");
                writeln("  mov  eax, BUFSIZE");
                writeln("  call inputstr\t\t; console input");
                writeln("  call copystrng");
                write_str("  mov  edi, [");   /* make string assignment */
                write_str(varname);
                write_str("]");
                writeln("\t\t\t; load address-pointer");
                writeln("  call copystrng_bffr\t\t; alloc memory and copy");
                write_str("  mov  ");
                write_str(varname);
                writeln(", eax\t\t\t; store address-pointer");
			/**/
                if(loc == 1)
                {   writeln("  call reset_cursor");
                }
                stringcopy = 1;			/* global flag */
                asninputstr = 1;
            }
            else						/* numeric assignment */
            {   type = get_Nvtype(pi);
                writeln("  mov  eax, BUFFR_SIZ");
                writeln("  call inputstr\t\t; console input");
                writeln("  invoke StrToFloat, esi, addr qLVAR");
                writeln("  FLD   qLVAR");
                if(type < 3)				/* integer types */
                {   write_str("  FISTP ");
                }
                else
                {   write_str("  FSTP ");
                }
                writeln(varname);
			/**/
                if(loc == 1)
                {   writeln("  call reset_cursor");
                }
                asninputstr = 1;
            }
        }
        else
        {   a_bort(ab_code, x);
        }
        pi = e_pos;
        ch = p_string[pi];
        if(strchr("; ,)$%!#@", ch))		/* jump over punctuation */
        {   pi = get_alpha(pi, len);    /* get to next alpha or string */
            ch = p_string[pi];
            e_pos = pi;
        }
    }
}
/*---------- end get_input ----------*/


void get_lninput()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, mark, loc=0, flag=0, ab_code=15, x=line_ndx;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    if(ch == '#')               /* this is a file: [LINE INPUT#1, var:] */
    {   lineinput_io();
        return;
    }
    else if(ch == ';')				/* do not echo newline */
    {   loc = 1;					/* Location Of Cursor */
        resetcursor = 1;
        pi = get_rightExp(pi);		/* get to next alpha or string */
        ch = p_string[pi];
        e_pos = pi;
    }
    while(flag == 0)
    {   strcpy(temp, "VARX");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;
        if((mark >= 0) && (mark == pi))
        {   mark = 1;
        }
        else 
        {   mark = 0;
        }
		/**/
        if(mark == 1)				/* OUPUT a quoted string */
        {   strcpy(varname, get_varname());
            strcat(varname, "$");
            write_str("  printstr ");
            writeln(varname);
        }
        else if(isalpha(ch))	    		/* INPUT a string$ variable */
        {   strcpy(varname, get_varname());
            if(loc == 1)
            {   writeln("  call wherexy");
            }
            strcat(varname, "$");
            writeln("  lea  eax, StringBffr");
            writeln("  mov  [eax], byte ptr 0");
            writeln("  mov  eax, BUFSIZE");
            writeln("  call inputstr\t\t; console input");
            writeln("  call copystrng");
            write_str("  mov  edi, [");   /* make string assignment */
            write_str(varname);
            write_str("]");
            writeln("\t\t\t; load address-pointer");
            writeln("  call copystrng_bffr\t\t; alloc memory and copy");
            write_str("  mov  ");
            write_str(varname);
            writeln(", eax\t\t\t; store address-pointer");
			/**/
            if(loc == 1)
            {   writeln("  call reset_cursor");
            }
            stringcopy = 1;			/* global flag */
            asninputstr = 1;
            flag = 1;
        }
        else
        {   a_bort(ab_code, x);
        }
        pi = e_pos;
        ch = p_string[pi];
        if(strchr("; ,)$", ch))		/* jump over punctuation */
        {   pi = get_alpha(pi, len);    /* get to next alpha or string */
            ch = p_string[pi];
            e_pos = pi;
        }
    }
}
/*---------- end get_lninput ----------*/


void parse_strArry(char *name)	    	/* string array assignment */
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, ndx, value, xcnt=0;

    strcpy(varname, name);			/* get destination */
    strcat(varname, "$");
		/**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_paramsCount(pi, len);	/* get params count */
		/**/
    writeln("; --------------------------------------------------");
    get_offset(varname, len, xcnt);		/* get destination offset */
    writeln("  push edi");
		/**/
    pi = e_pos;
    pi++;
    pi = iswhiter(pi);
    e_pos = pi;
		/**/
    Match('=');
    writeln("  lea  eax, StringBffr");
    writeln("  mov  [eax], byte ptr 0\t\t; clear string-copy buffer");
		/**/
    str_express(varname);			/* now get assignment string */
		/**/
    writeln("  pop  edi");
    writeln("  push edi");
    writeln("  mov  eax, edi");
    writeln("  mov  edi, [eax]");		/* make string assignment */
    writeln("  call copystrng_bffr\t\t; alloc memory and copy");
    writeln("  pop  edi");			/* get destination address */
    writeln("  mov  [edi], eax\t\t\t; store address-pointer");
}
/*---------- end parse_strArry ----------*/


void get_offset(char *name, int len, int xcnt)
{   char ch, varname[VAR_NAME], temp[6];
    int pi, ndx, value;

    strcpy(varname, name);			/* get destination */
		/**/
    write_str("  mov  edi, offset ");
    writeln(varname);
    writeln("  push edi");			/* save address to array */
    writeln("  add  edi, 6");
    writeln("  mov  esi, offset array_mtrx");
    writeln("  push esi");
		/**/
    pi = e_pos;
    pi = get_paren(pi, len);			/* array$(3,1,0) = str$ */
    ch = p_string[pi];				/* ------^			*/
    while((xcnt > 1) && (ch != ')'))
    {   pi = get_alnum(pi, len);
        e_pos = pi;
        ch = p_string[pi];
        if(isdigit(ch))
        {   value = (int) get_avalue();
            sprintf(temp, "%d", value);
            write_str("  mov  [esi], word ptr ");
            writeln(temp);
            writeln("  add  esi, 2");
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());
            write_str("  mov  eax, ");
            writeln(varname);
            writeln("  mov  [esi], ax");
            writeln("  add  esi, 2");
        }
        pi = e_pos;
        ch = p_string[pi];
        xcnt--;
    }
    writeln("  mov  [esi], word ptr 0");
    writeln("  add  esi, 2");
		/**/
    pi = get_alnum(pi, len);
    e_pos = pi;
    ch = p_string[pi];
    if(isdigit(ch))
    {   value = (int) get_avalue();
        sprintf(temp, "%d", value);
        write_str("  mov  [esi], word ptr ");
        writeln(temp);
    }
    else if(isalpha(ch))
    {   strcpy(varname, get_varname());
        write_str("  mov  eax, ");
        writeln(varname);
        writeln("  mov  [esi], ax");
    }
    writeln("  pop  esi");
    writeln("  call getArryOffst");		/* get array(index) offset */
    writeln("  pop  esi");			/* array base address */
    writeln("  mov  edi, [esi]");
    writeln("  add  edi, eax");
		/**/
    getArryOffst = 1;
}
/*---------- end get_offset ----------*/

